# Ipopt::SensAmplTNLP Class Reference

`#include <SensAmplTNLP.hpp>`

Inheritance diagram for Ipopt::SensAmplTNLP:
[legend]

List of all members.

## Public Member Functions
| SensAmplTNLP (const SmartPtr< const Journalist > &jnlst, const SmartPtr< OptionsList > options, char **&argv, SmartPtr< AmplSuffixHandler > suffix_handler=NULL, bool allow_discrete=false, SmartPtr< AmplOptionsList > ampl_options_list=NULL, const char *ampl_option_string=NULL, const char *ampl_invokation_string=NULL, const char *ampl_banner_string=NULL, std::string *nl_file_content=NULL)
| This class is the Sens-wrapper for the ampltnlp, adapts the get bounds function and some others to our needs.
virtual | ~SensAmplTNLP ()
virtual bool | get_bounds_info (Index n, Number *x_l, Number *x_u, Index m, Number *g_l, Number *g_u)
| returns bounds of the nlp.
void | set_sens_solution (Index idx, SmartPtr< IteratesVector > sens_sol)
virtual void | finalize_metadata (Index n, const StringMetaDataMapType &var_string_md, const IntegerMetaDataMapType &var_integer_md, const NumericMetaDataMapType &var_numeric_md, Index m, const StringMetaDataMapType &con_string_md, const IntegerMetaDataMapType &con_integer_md, const NumericMetaDataMapType &con_numeric_md)
| This method is called just before finalize_solution.
virtual void | finalize_solution (SolverReturn status, Index n, const Number *x, const Number *z_L, const Number *z_U, Index m, const Number *g, const Number *lambda, Number obj_value, const IpoptData *ip_data, IpoptCalculatedQuantities *ip_cq)
| This method is called when the algorithm is complete so the TNLP can store/write the solution.
const Index * | get_index_suffix (const char *suffix_name)
std::vector< Index > | get_index_suffix_vec (const char *suffix_name)
const Number * | get_number_suffix (const char *suffix_name)
std::vector< Number > | get_number_suffix_vec (const char *suffix_name)
const Index * | get_index_suffix_constr (const char *suffix_name)
std::vector< Index > | get_index_suffix_constr_vec (const char *suffix_name)
const Number * | get_number_suffix_constr (const char *suffix_name)
virtual bool | get_var_con_metadata (Index n, StringMetaDataMapType &var_string_md, IntegerMetaDataMapType &var_integer_md, NumericMetaDataMapType &var_numeric_md, Index m, StringMetaDataMapType &con_string_md, IntegerMetaDataMapType &con_integer_md, NumericMetaDataMapType &con_numeric_md)
| returns names and other meta data for the variables and constraints Overloaded from TNLP
## Private Attributes
SmartPtr< const Journalist > | jnlst_
| local copy of current lower and upper bounds - needed for parameter change
SmartPtr< OptionsList > | options_
bool | have_parameters_
Index * | parameter_flags_
Number * | parameter_values_
Index | n_sens_steps_
| important Options
bool | run_sens_
bool | compute_red_hessian_
std::vector< SmartPtr < IteratesVector > > | sens_sol_

## Detailed Description

Definition at line 17 of file SensAmplTNLP.hpp.

## Constructor & Destructor Documentation

Ipopt::SensAmplTNLP::SensAmplTNLP | ( | const SmartPtr< const Journalist > & | jnlst,
|  | const SmartPtr< OptionsList > | options,
|  | char **& | argv,
|  | SmartPtr< AmplSuffixHandler > | suffix_handler = `NULL`,
|  | bool | allow_discrete = `false`,
|  | SmartPtr< AmplOptionsList > | ampl_options_list = `NULL`,
|  | const char * | ampl_option_string = `NULL`,
|  | const char * | ampl_invokation_string = `NULL`,
|  | const char * | ampl_banner_string = `NULL`,
|  | std::string * | nl_file_content = `NULL` |
| ) |  |  |

This class is the Sens-wrapper for the ampltnlp, adapts the get bounds function and some others to our needs.

constructor

virtual Ipopt::SensAmplTNLP::~SensAmplTNLP | ( |  | ) | `[virtual]`

## Member Function Documentation

virtual bool Ipopt::SensAmplTNLP::get_bounds_info | ( | Index | n,
|  | Number * | x_l,
|  | Number * | x_u,
|  | Index | m,
|  | Number * | g_l,
|  | Number * | g_u |
| ) |  |  | `[virtual]`

returns bounds of the nlp.

Overloaded from AmplTNLP

Reimplemented from Ipopt::AmplTNLP.

void Ipopt::SensAmplTNLP::set_sens_solution | ( | Index | idx,
|  | SmartPtr< IteratesVector > | sens_sol |
| ) |  |  |

virtual void Ipopt::SensAmplTNLP::finalize_metadata | ( | Index | n,
|  | const StringMetaDataMapType & | var_string_md,
|  | const IntegerMetaDataMapType & | var_integer_md,
|  | const NumericMetaDataMapType & | var_numeric_md,
|  | Index | m,
|  | const StringMetaDataMapType & | con_string_md,
|  | const IntegerMetaDataMapType & | con_integer_md,
|  | const NumericMetaDataMapType & | con_numeric_md |
| ) |  |  | `[virtual]`

This method is called just before finalize_solution.

With this method, the algorithm returns any metadata collected during its run, including the metadata provided by the user with the above get_var_con_metadata. Each metadata can be of type string, integer, and numeric. It can be associated to either the variables or the constraints. The metadata that was associated with the primal variable vector is stored in var_..._md. The metadata associated with the constraint multipliers is stored in con_..._md. The metadata associated with the bound multipliers is stored in var_..._md, with the suffixes "_z_L", and "_z_U", denoting lower and upper bounds.

Reimplemented from Ipopt::TNLP.

virtual void Ipopt::SensAmplTNLP::finalize_solution | ( | SolverReturn | status,
|  | Index | n,
|  | const Number * | x,
|  | const Number * | z_L,
|  | const Number * | z_U,
|  | Index | m,
|  | const Number * | g,
|  | const Number * | lambda,
|  | Number | obj_value,
|  | const IpoptData * | ip_data,
|  | IpoptCalculatedQuantities * | ip_cq |
| ) |  |  | `[virtual]`

This method is called when the algorithm is complete so the TNLP can store/write the solution.

Reimplemented from Ipopt::AmplTNLP.

const Index* Ipopt::SensAmplTNLP::get_index_suffix | ( | const char * | suffix_name | ) |

std::vector<Index> Ipopt::SensAmplTNLP::get_index_suffix_vec | ( | const char * | suffix_name | ) |

const Number* Ipopt::SensAmplTNLP::get_number_suffix | ( | const char * | suffix_name | ) |

std::vector<Number> Ipopt::SensAmplTNLP::get_number_suffix_vec | ( | const char * | suffix_name | ) |

const Index* Ipopt::SensAmplTNLP::get_index_suffix_constr | ( | const char * | suffix_name | ) |

std::vector<Index> Ipopt::SensAmplTNLP::get_index_suffix_constr_vec | ( | const char * | suffix_name | ) |

const Number* Ipopt::SensAmplTNLP::get_number_suffix_constr | ( | const char * | suffix_name | ) |

virtual bool Ipopt::SensAmplTNLP::get_var_con_metadata | ( | Index | n,
|  | StringMetaDataMapType & | var_string_md,
|  | IntegerMetaDataMapType & | var_integer_md,
|  | NumericMetaDataMapType & | var_numeric_md,
|  | Index | m,
|  | StringMetaDataMapType & | con_string_md,
|  | IntegerMetaDataMapType & | con_integer_md,
|  | NumericMetaDataMapType & | con_numeric_md |
| ) |  |  | `[virtual]`

returns names and other meta data for the variables and constraints Overloaded from TNLP

Reimplemented from Ipopt::AmplTNLP.

## Member Data Documentation

SmartPtr<const Journalist> Ipopt::SensAmplTNLP::jnlst_`[private]`

local copy of current lower and upper bounds - needed for parameter change

Reimplemented from Ipopt::AmplTNLP.

Definition at line 88 of file SensAmplTNLP.hpp.

SmartPtr<OptionsList> Ipopt::SensAmplTNLP::options_`[private]`

Definition at line 89 of file SensAmplTNLP.hpp.

bool Ipopt::SensAmplTNLP::have_parameters_`[private]`

Definition at line 91 of file SensAmplTNLP.hpp.

Index* Ipopt::SensAmplTNLP::parameter_flags_`[private]`

Definition at line 93 of file SensAmplTNLP.hpp.

Number* Ipopt::SensAmplTNLP::parameter_values_`[private]`

Definition at line 94 of file SensAmplTNLP.hpp.

Index Ipopt::SensAmplTNLP::n_sens_steps_`[private]`

important Options

Definition at line 97 of file SensAmplTNLP.hpp.

bool Ipopt::SensAmplTNLP::run_sens_`[private]`

Definition at line 98 of file SensAmplTNLP.hpp.

bool Ipopt::SensAmplTNLP::compute_red_hessian_`[private]`

Definition at line 99 of file SensAmplTNLP.hpp.

std::vector< SmartPtr<IteratesVector> > Ipopt::SensAmplTNLP::sens_sol_`[private]`

Definition at line 101 of file SensAmplTNLP.hpp.

The documentation for this class was generated from the following file:

- contrib/sIPOPT/AmplSolver/SensAmplTNLP.hpp

All Classes Files Functions Variables Typedefs Enumerations Enumerator Friends Defines